
proc colorize_c {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove text begin ende
	$w tag remove rem2 begin ende
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(c.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(c.col1.[string range $word 0 0]) $word] != -1} {
				$w tag add col1 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "^\[ \t\]*#\[ \t\]*" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word "#[$w get last next]"
			if {[lsearch -exact $words(c.col2.#) $word] != -1} {
				$w tag add col2 $ind next
			}
			$w mark set last next
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp {"[^"]*("|$)} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w tag add text $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search {//} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w tag add rem2 $ind "$ind lineend"
			$w mark set last "$ind+1l linestart"
		} else break
	}
}

proc colorize_java {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove text begin ende
	$w tag remove rem2 begin ende
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(java.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(java.col1.[string range $word 0 0]) $word] != -1} {
				$w tag add col1 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp {"[^"]*("|$)} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w tag add text $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search {//} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w tag add rem2 $ind "$ind lineend"
			$w mark set last "$ind+1l linestart"
		} else break
	}
}

proc colorize_tcl {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove exec begin ende
	$w tag remove rem1 begin ende
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(^|\[\[;,\{\}\])\[ \t\]*\[$chset(tcl.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(tcl.col1.[string range $word 0 0]) $word] != -1} {
				$w tag add col1 last-1c next
			}
			$w mark set last next
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(^|\[\[;\{\}\])\[ \t\]*\[$chset(tcl.col2)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(tcl.col2.[string range $word 0 0]) $word] != -1} {
				$w tag add col2 last-1c next
			}
			$w mark set last next
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(^|;)\[ \t\]*#" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			set type rem1
			if {[$w index last] == 1.1} {
				if {[$w get last last+1c] == {!}} {
					set type exec
				}
			}
			$w mark set next {last lineend}
			$w tag add $type last-1c next
			$w mark set last next+1c
		} else break
	}
}

proc colorize_sh {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove exec begin ende
	$w tag remove text begin ende
	$w tag remove rem1 begin ende
	$w mark set last begin
	while {[set ind [$w search -regexp {[][&:`<>{}]} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last $ind+1c
			$w tag add col1 $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(^|\[\[;\{\}\])\[ \t\]*\[$chset(sh.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(sh.col1.[string range $word 0 0]) $word] != -1} {
				$w tag add col2 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp {("[^"]*("|$))|('[^']*('|$))} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w tag add text $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "^(\"\[^\"\]*\")*\[^\"\]*#" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			set type rem1
			if {[$w index last] == 1.1} {
				if {[$w get last last+1c] == {!}} {
					set type exec
				}
			}
			$w mark set next {last lineend}
			$w tag add $type last-1c next
			$w mark set last next+1c
		} else break
	}
}

proc colorize_tex {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove rem1 begin ende
	$w mark set last begin
	while {[set ind [$w search -regexp {[][&${}]} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last $ind+1c
			$w tag add col1 $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp {\\([a-zA-Z0-9]+|[^A-Za-z0-9])} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w tag add col2 $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp {(^|[^\\])%} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w tag add rem1 "$ind+[expr $num-1]c" "$ind lineend"
			$w mark set last "$ind+1l linestart"
		} else break
	}
}

proc textsearch {w opts start stop comp} {

	if {[set pos [eval $w search $opts $start $stop]] == {}} {
		return $start
	}
	if {[$w compare $start $comp $pos]} {
		return $pos
	} else {
		return $start
	}
}

proc colorize_html {w cpos iend} {
	global	words color back chset

	set begin [textsearch $w "-backwards {<}" [textsearch $w "-backwards {<}" $cpos 1.0 >] 1.0 >]
	set ende [textsearch $w "-forwards {>}" [textsearch $w "-forwards {>}" $iend end <] end <]
	$w mark set begin "$begin linestart"
	$w mark set ende "$ende+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove text begin ende
	$w tag remove rem1 begin ende
	$w tag remove exec begin ende
	$w mark set last begin
	while {[set ind [$w search -count num -nocase -regexp "<(!|/\[$chset(html.col1)\]|\[$chset(html.col1)\])" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			if {[set i2 [$w search -exact {>} $ind ende]] == {}} break
			$w mark set last $i2+1c
			set add {1c}
			$w mark set next "$ind+$add wordend"
			set word [$w get $ind+$add next]
			if {$word == {!}} {
				if {[$w get $ind $ind+4c] == {<!--} && [$w get last-3c last] == {-->}} {
					$w tag add rem1 $ind last
				}
			} else {
				if {$word == {/}} {
					set add {2c}
					$w mark set next "$ind+$add wordend"
					set word [$w get $ind+$add next]
				}
				set word [string tolower $word]
				if {[lsearch -exact $words(html.col1.[string range $word 0 0]) $word] != -1} {
					$w tag add col1 $ind+$add next
					$w mark set ind next
					while {[set ind [$w search -count num -nocase -regexp "\[$chset(html.col2)\]\[-a-zA-Z\]*" next last]] != {}} {
						if {[$w compare $ind >= next]} {
							$w mark set next "$ind+$num c"
							set word [string tolower [$w get $ind next]]
							if {[lsearch -exact $words(html.col2.[string range $word 0 0]) $word] != -1} {
								$w tag add col2 $ind next
							}
						}
					}
					$w mark set next ind
					while {[set ind [$w search -count num -regexp {"[^"]*"} next last]] != {}} {
						if {[$w compare $ind >= next]} {
							$w mark set next "$ind+$num c"
							$w tag add text $ind next
						}
					}
				}
			}
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "&\[$chset(html.col3)\].*;" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind+$num c"
			set word [$w get $ind+1c last-1c]
			if {[lsearch -exact $words(html.col3.[string range $word 0 0]) $word] != -1} {
				$w tag add exec $ind last
			}
		} else break
	}
	if {[winfo exists .m.html]} {
		pack .m.html
	} else {
		html_makemenus
		}
}

proc colorize_perl {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove text begin ende
	$w tag remove rem1 begin ende
	$w tag remove exec begin ende
	$w mark set last begin
	while {[set ind [$w search -regexp {[$@]} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last $ind+1c
			$w tag add col1 $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(perl.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(perl.col1.[string range $word 0 0]) $word] != -1} {
				$w tag add col2 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp {"[^"]*("|$)} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w tag add text $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(^|;)\[ \t\]*#" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			set type rem1
			if {[$w index last] == 1.1} {
				if {[$w get last last+1c] == {!}} {
					set type exec
				}
			}
			$w mark set next {last lineend}
			$w tag add $type last-1c next
			$w mark set last next+1c
		} else break
	}
}

proc colorize_matlab {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove text begin ende
	$w tag remove rem2 begin ende
	$w mark set last begin
	while {[set ind [$w search -regexp {[][;:]} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last $ind+1c
			$w tag add col2 $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(matlab.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(matlab.col1.[string range $word 0 0]) $word] != -1} {
				$w tag add col1 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -exact {#} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w tag add rem2 $ind "$ind lineend"
			$w mark set last "$ind+1l linestart"
		} else break
	}
}

proc colorize_hdla {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove rem1 begin ende
	$w mark set last begin
	while {[set ind [$w search -nocase -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(hdla.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(hdla.col1.[string tolower [string range $word 0 0]]) [string tolower $word]] != -1} {
				$w tag add col1 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -nocase -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(hdla.col2)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(hdla.col2.[string tolower [string range $word 0 0]]) [string tolower $word]] != -1} {
				$w tag add col2 $ind next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -- -- last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w tag add rem2 $ind "$ind lineend"
			$w mark set last "$ind+1l linestart"
		} else break
	}
}

proc colorize_dsp {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove text begin ende
	$w mark set last begin
	while {[set ind [$w search -nocase -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(dsp.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(dsp.col1.[string tolower [string range $word 0 0]]) [string tolower $word]] != -1} {
				$w tag add col1 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -nocase -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(dsp.col2)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(dsp.col2.[string tolower [string range $word 0 0]]) [string tolower $word]] != -1} {
				$w tag add col2 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
}

proc colorize_pld {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove text begin ende
	$w tag remove rem2 begin ende
	$w mark set last begin
	while {[set ind [$w search -nocase -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(pld.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(pld.col1.[string tolower [string range $word 0 0]]) [string tolower $word]] != -1} {
				$w tag add col1 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -nocase -regexp "#\[$chset(dsp.col2)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set next "$ind+1c wordend"
			set word [$w get $ind+1c next]
			if {[lsearch -exact $words(pld.col2.[string tolower [string range $word 0 0]]) [string tolower $word]] != -1} {
				$w tag add col2 $ind next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -exact {"} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w tag add rem2 $ind "$ind lineend"
			$w mark set last "$ind+1l linestart"
		} else break
	}
}


proc colorize_mafia {w cpos iend} {
	global	words color back chset

	$w mark set begin "$cpos linestart"
	$w mark set ende "$iend+1l linestart"
	$w tag remove col1 begin ende
	$w tag remove col2 begin ende
	$w tag remove exec begin ende
	$w tag remove rem1 begin ende

	$w mark set last begin
	while {[set ind [$w search -count num -regexp {#([a-zA-Z0-9]+|[^A-Za-z0-9])} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w tag add exec $ind last
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp {(^\[^\])\$} last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w tag add rem1 "$ind+[expr $num-1]c" "$ind lineend"
			$w mark set last "$ind+1l linestart"
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(mafia.col1)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(mafia.col1.[string range $word 0 0]) $word] != -1} {
				$w tag add col1 last-1c next
			}
			$w mark set last next-1c
		} else break
	}
	$w mark set last begin
	while {[set ind [$w search -count num -regexp "(\[^A-Za-z0-9_\]|^)\[$chset(mafia.col2)\]" last ende]] != {}} {
		if {[$w compare $ind >= last]} {
			$w mark set last "$ind + $num c"
			$w mark set next {last wordend}
			set word [$w get last-1c next]
			if {[lsearch -exact $words(mafia.col2.[string range $word 0 0]) $word] != -1} {
				$w tag add col2 last-1c next
			}
			$w mark set last next-1c
		} else break
	}


}

proc colorize {w cpos iend} {
	global	mode fno

	switch $mode($fno) {
		C	{ colorize_c $w $cpos $iend }
		JAVA	{ colorize_java $w $cpos $iend }
		TCL	{ colorize_tcl $w $cpos $iend }
		SH	{ colorize_sh $w $cpos $iend }
		HTML	{ colorize_html $w $cpos $iend }
		TEX	{ colorize_tex $w $cpos $iend }
		PERL	{ colorize_perl $w $cpos $iend }
		MAFIA	{ colorize_mafia $w $cpos $iend }
		MATLAB	{ colorize_matlab $w $cpos $iend }
		HDLA	{ colorize_hdla $w $cpos $iend }
		DSP	{ colorize_dsp $w $cpos $iend }
		PLD	{ colorize_pld $w $cpos $iend }
	}
}
# $Extended$File$Info$
#
