
set html_menudefs(html) {
	{sub {Document} 0 html_document}
	{sub {Head content} 0 html_headcont}
	{sub {Body Head} 0 html_headl}
	{sub {     Text} 5 html_text}
	{sub {     Lists} 5 html_list}
	{sub {     Tables} 5 html_tables}
	{sub {     Anchor} 5 html_a}
	{sub {     Objects} 5 html_objects}
	{sub {Frames} 0 html_frames}
	{sub {Forms} 0 html_forms}
	{sub {Scripts} 0 html_scripts}
}

set html_menudefs(html_document) {
	{sub {HTML version} 0 html_version}
	{sub {HTML root element} 0 html_html}
	{sub {Head element} 0 html_head}
	{sub {Body element} 0 html_body}
}

set html_menudefs(html_version) {
	{com {Strict} 0 {.. strict.dtd>} {command {insert coms html(version.strict)}}}
	{com {Loose} 0 {.. loose.dtd>} {command {insert coms html(version.loose)}}}
	{com {Frameset} 0 {.. frameset.dtd>} {command {insert coms html(version.frame)}}}
	{com {Lat1} 0 {.. HTMLlat1.ent>} {command {insert coms html(version.lat)}}}
	{com {Symbol} 0 {.. HTMLsymbol.ent>} {command {insert coms html(version.symb)}}}
	{com {Special} 0 {.. HTMLspecial.ent>} {command {insert coms html(version.spec)}}}
}

set html_menudefs(html_html) {
	{com {HTML element} 0 {<HTML> </HTML>} {command {insert coms html(html.html)}}}
	{}
	{sub {i18} 0 html_i18n}
}

set html_menudefs(html_head) {
	{com {Head} 0 {<HEAD> </HEAD>} {command {insert coms html(head.head)}}}
	{}
	{sub {i18} 0 html_i18n}
	{com {Profile} 0 {+ PROFILE=} {command {insert coms html(head.profile)}}}
}

set html_menudefs(html_body) {
	{com {Plain} 0 {<BODY> </BODY>} {command {insert coms html(body.plain)}}}
	{}
	{com {On load} 0 {+ ONLOAD= } {command {insert coms html(body.bgprop)}}}
	{com {On unload} 0 {+ ONUNLOAD=} {command {insert coms html(body.bgprop)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_headcont) {
	{sub {Title} 0 html_title}
	{sub {Base} 0 html_base}
	{sub {Style} 0 html_style}
	{sub {Meta} 0 html_meta}
	{sub {Link} 0 html_hlink}
	{sub {Object} 0 html_object}
}

set html_menudefs(html_title) {
	{com {Title element} 0 {<TITLE></TITLE>} {command {insert coms html(title.title)}}}
	{}
	{sub {i18} 0 html_i18n}
}

set html_menudefs(html_base) {
	{com {Document base} 0 {<BASE HREF=>} {command {insert coms html(base.base)}}}
	{}
	{com {Target} 0 {+ TARGET} {command {insert coms html(base.target)}}}
}

set html_menudefs(html_script) {
	{com {Script} 0 {<SCRIPT TYPE=> </SCRIPT>} {command {insert coms html(script.script)}}}
	{}
	{com {Type} 0 {+ TYPE=} {command {insert coms html(script.type)}}}
	{com {Source} 0 {+ SRC=} {command {insert coms html(script.src)}}}
	{com {Defer} 0 {+ DEFER} {command {insert coms html(script.defer)}}}
	{com {Charset} 0 {+ CHARSET=} {command {insert coms html(script.charset)}}}
}

set html_menudefs(html_style) {
	{com {Style} 0 {<STYLE TYPE=> </TYPE>} {command {insert coms html(style.main)}}}
	{}
	{com {Media} 0 {+ MEDIA=} {command {insert coms html(style.media)}}}
	{com {Title} 0 {+ TITLE=} {command {insert coms html(style.title)}}}
	{sub {i18} 0 html_i18n}
}

set html_menudefs(html_meta) {
	{com {Meta element} 0 {<META CONTENT=>} {command {insert coms html(meta.main)}}}
	{}
	{com {Name} 0 {+ NAME=} {command {insert coms html(meta.name)}}}
	{com {HTTP equiv} 0 {+ HTTP-EQUIV=} {command {insert coms html(meta.equiv)}}}
	{com {Scheme} 0 {+ SCHEME=} {command {insert coms html(meta.scheme)}}}
	{sub {i18} 0 html_i18n}
}

set html_menudefs(html_hlink) {
	{com {Link} 0 {<LINK ..>} {command {insert coms html(hlink.main)}}}
	{}
	{com {Href} 0 {+ HREF=} {command {insert coms html(hlink.href)}}}
	{com {Target} 0 {+ TARGET=} {command {insert coms html(hlink.target)}}}
	{com {Href language} 0 {+ HREFLANG=} {command {insert coms html(hlink.hreflang)}}}
	{com {Content type} 0 {+ TYPE=} {command {insert coms html(hlink.type)}}}
	{com {Forward link} 0 {+ REL=} {command {insert coms html(hlink.rel)}}}
	{com {Reverse link} 0 {+ REV=} {command {insert coms html(hlink.rev)}}}
	{com {Media} 0 {+ MEDIA=} {command {insert coms html(hlink.media)}}}
	{com {Character set} 0 {+ CHARSET=} {command {insert coms html(hlink.charset)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_headl) {
	{com {Heading 1.} 8 {<H1>} {command {insert coms html(headl.h1)}}}
	{com {Heading 2.} 0 {<H2>} {command {insert coms html(headl.h2)}}}
	{com {Heading 3.} 0 {<H3>} {command {insert coms html(headl.h3)}}}
	{com {Heading 4.} 0 {<H4>} {command {insert coms html(headl.h4)}}}
	{com {Heading 5.} 0 {<H5>} {command {insert coms html(headl.h5)}}}
	{com {Heading 6.} 0 {<H6>} {command {insert coms html(headl.h6)}}}
	{com {Horizontal rule} 0 {<HR>} {command {insert coms html(headl.hr)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_text) {
	{sub {Phrase elements} 0 html_phrase}
	{sub {Quotation} 0 html_quotation}
	{sub {Sub/super-script} 0 html_subsup}
	{sub {Paragraphs} 0 html_para}
	{sub {Line breaks} 0 html_linebr}
	{sub {Preformatted} 0 html_pre}
	{sub {Marking} 0 html_marking}
}

set html_menudefs(html_phrase) {
	{com {Emphasis} 0 {<EM></EM>} {command {insert coms html(phrase.em)}}}
	{com {Stronger emphasis} 0 {<STRONG></STRONG>} {command {insert coms html(phrase.strong)}}}
	{com {Instance definition} 0 {<DFN></DFN>} {command {insert coms html(phrase.dfn)}}}
	{com {Computer code} 0 {<CODE></CODE>} {command {insert coms html(phrase.code)}}}
	{com {Sample} 0 {<SAMP></SAMP>} {command {insert coms html(phrase.samp)}}}
	{com {User entered text} 0 {<KBD></KBD>} {command {insert coms html(phrase.kbd)}}}
	{com {Variable, argument} 0 {<VAR></VAR>} {command {insert coms html(phrase.var)}}}
	{com {Citation} 0 {<CITE></CITE>} {command {insert coms html(phrase.cite)}}}
	{com {Abbriviated form} 0 {<ABBR></ABBR>} {command {insert coms html(phrase.abbr)}}}
	{com {Acronym} 0 {<ACRONYM></ACRONYM>} {command {insert coms html(phrase.acr)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_quotation) {
	{com {Blockquotation} 0 {<BLOCKQUOTE></BLOCKQUOTE>} {command {insert coms html(quotation.bl)}}}
	{com {Inline quotation} 0 {<Q></Q>} {command {insert coms html(quotation.q)}}}
	{}
	{com {Source URI} 0 {+ CITE=} {command {insert coms html(quotation.cite)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_subsup) {
	{com {Subscripts} 0 {<SUB></SUB>} {command {insert coms html(subsup.sub)}}}
	{com {Superscripts} 0 {<SUP></SUP>} {command {insert coms html(subsup.sup)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_para) {
	{com {Paragraph} 0 {<P></P>} {command {insert coms html(para.par)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_linebr) {
	{com {Line break} 0 {<BR>} {command {insert coms html(linebr.br)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{}
	{com {Prohibit break} 0 {&nbsp;} {command {insert coms html(linebr.nbsp)}}}
	{com {Soft hyphen} 0 {&shy;} {command {insert coms html(linebr.shy)}}}
}

set html_menudefs(html_pre) {
	{com {Preformatted} 0 {<PRE> </PRE>} {command {insert coms html(pre.pre)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_marking) {
	{com {Inserted text} 0 {<INS></INS>} {command {insert coms html(marking.ins)}}}
	{com {Deleted text} 0 {<DEL></DEL>} {command {insert coms html(marking.del)}}}
	{}
	{com {Info on reason} 0 {+ cite=} {command {insert coms html(marking.cite)}}}
	{com {Change date time} 0 {+ datetime=} {command {insert coms html(marking.dattim)}}}
}

set html_menudefs(html_list) {
	{com {Unordered lists} 0 {<UL> </UL>} {command {insert coms html(list.bullet)}}}
	{com {Ordered lists} 0 {<OL> </OL>} {command {insert coms html(list.num)}}}
	{com {Entry} 0 {<LI></LI>} {command {insert coms html(list.entry)}}}
	{com {Definition list} 0 {<DL> </DL>} {command {insert coms html(list.dl)}}}
	{com {Definition term} 0 {<DT> </DT>} {command {insert coms html(list.dt)}}}
	{com {Definition description} 0 {<DD></DD>} {command {insert coms html(list.dd)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_tables) {
	{sub {Table} 0 html_table}
	{sub {Caption} 0 html_caption}
	{sub {Column groups} 0 html_colgrp}
	{sub {Row groups} 0 html_rowgrp}
	{sub {Table row} 0 html_tabrow}
	{sub {Table cell} 0 html_tabcel}
}

set html_menudefs(html_table) {
	{com {Plain} 0 {<TABLE> </TABLE>} {command {insert coms html(table.main)}}}
	{}
	{com {Summary} 0 {+ SUMMARY=} {command {insert coms html(table.summary)}}}
	{com {Width} 0 {+ WIDTH=} {command {insert coms html(table.width)}}}
	{com {Border} 0 {+ BORDER=} {command {insert coms html(table.border)}}}
	{com {Frame} 0 {+ FRAME=} {command {insert coms html(table.frame)}}}
	{com {Rules} 0 {+ RULES=} {command {insert coms html(table.rules)}}}
	{com {Cell spacing} 0 {+ CELLSPACING=} {command {insert coms html(table.space)}}}
	{com {Cell padding} 0 {+ CELLPADDING=} {command {insert coms html(table.padd)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_caption) {
	{com {Caption} 0 {<CAPTION></CAPTION>} {command {insert coms html(caption.main)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_colgrp) {
	{com {Col group} 0 {<COLGROUP> </COLGROUP>} {command {insert coms html(colgrp.colgrp)}}}
	{com {Col group} 0 {<COLGROUP>} {command {insert coms html(colgrp.grp)}}}
	{com {Column} 0 {<COL>} {command {insert coms html(colgrp.col)}}}
	{}
	{com {Span} 0 {+ SPAN=} {command {insert coms html(colgrp.span)}}}
	{com {Width} 0 {+ WIDTH=} {command {insert coms html(colgrp.width)}}}
	{sub {Align} 0 html_align}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_rowgrp) {
	{com {Header} 0 {<THEAD> </THEAD>} {command {insert coms html(rowgrp.head)}}}
	{com {Footer} 0 {<TFOOT> </TFOOT>} {command {insert coms html(rowgrp.foot)}}}
	{com {Body} 0 {<TBODY> </TBODY>} {command {insert coms html(rowgrp.body)}}}
	{}
	{sub {Align} 0 html_align}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
	{}
	{com {Help} 0 {Row groups} {command {help html ??}}}
}

set html_menudefs(html_tabrow) {
	{com {Row} 0 {<TR> </TR>} {command {insert coms html(tabrow.row)}}}
	{}
	{sub {Align} 0 html_align}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_tabcel) {
	{com {Head} 0 {<TH></TH>} {command {insert coms html(tabcel.head)}}}
	{com {Data} 0 {<TD></TD>} {command {insert coms html(tabcel.data)}}}
	{}
	{com {Abbreviation} 0 {+ ABBR=} {command {insert coms html(tabcel.abbr)}}}
	{com {Names groups} 0 {+ AXIS=} {command {insert coms html(tabcel.axis)}}}
	{com {List if ID's} 0 {+ HEADERS=} {command {insert coms html(tabcel.headers)}}}
	{com {Scope} 0 {+ SCOPE=} {command {insert coms html(tabcel.scope)}}}
	{com {Rowspan} 0 {+ ROWSPAN=} {command {insert coms html(tabcel.rows)}}}
	{com {Colspan} 0 {+ COLSPAN=} {command {insert coms html(tabcel.cols)}}}
	{sub {Align} 0 html_align}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_a) {
	{com {Plain} 0 {<A></A>} {command {insert coms html(a.main)}}}
	{}
	{com {Name} 0 {+ NAME=} {command {insert coms html(a.name)}}}
	{com {Href} 0 {+ HREF=} {command {insert coms html(a.href)}}}
	{com {Target} 0 {+ TARGET=} {command {insert coms html(a.target)}}}
	{com {Type} 0 {+ TYPE=} {command {insert coms html(a.type)}}}
	{com {Hreflang} 0 {+ HREFLANG=} {command {insert coms html(a.hreflang)}}}
	{com {Charset} 0 {+ CHARSET=} {command {insert coms html(a.charset)}}}
	{com {Rel} 0 {+ REL=} {command {insert coms html(a.rel)}}}
	{com {Rev} 0 {+ REV=} {command {insert coms html(a.rev)}}}
	{com {Accesskey} 0 {+ ACCESSKEY=} {command {insert coms html(a.accesskey)}}}
	{com {Shape} 0 {+ SHAPE=} {command {insert coms html(a.shape)}}}
	{com {Coords} 0 {+ COORDS=} {command {insert coms html(a.coords)}}}
	{com {Tab index} 0 {+ TABINDEX=} {command {insert coms html(a.tabindex)}}}
	{com {On get focus} 0 {+ ONFOCUS=} {command {insert coms html(a.onfocus)}}}
	{com {On lost focus} 0 {+ ONBLUR=} {command {insert coms html(a.onblur)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_objects) {
	{sub {Images} 0 html_img}
	{sub {Objects} 0 html_obj}
	{sub {Image maps} 0 html_maps}
}

set html_menudefs(html_img) {
	{com {Plain} 0 {<IMG SRC= ..>} {command {insert coms html(img.main)}}}
	{}
	{com {Long desc} 0 {+ LONGDESC=} {command {insert coms html(img.longdesc)}}}
	{com {Name} 0 {+ NAME=} {command {insert coms html(img.name)}}}
	{com {Width} 0 {+ WIDTH=} {command {insert coms html(img.width)}}}
	{com {Height} 0 {+ HEIGHT=} {command {insert coms html(img.height)}}}
	{com {Client map} 0 {+ USEMAP=} {command {insert coms html(img.usemap)}}}
	{com {Serever nap} 0 {+ ISMAP} {command {insert coms html(img.ismap)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_obj) {
	{sub {Object} 0 html_object}
	{sub {Parameters} 0 html_param}
}

set html_menudefs(html_param) {
	{com {Plain} 0 {<PARAM NAME=>} {command {insert coms html(param.main)}}}
	{}
	{com {Id} 0 {+ ID=} {command {insert coms html(param.id)}}}
	{com {Value} 0 {+ VALUE=} {command {insert coms html(param.value)}}}
	{com {Value type} 0 {+ VALUETYPE=} {command {insert coms html(param.valuetype)}}}
	{com {Type} 0 {+ TYPE=} {command {insert coms html(param.type)}}}
}

set html_menudefs(html_maps) {
	{sub {Image maps} 6 html_map}
	{sub {Image area} 6 html_area}
}

set html_menudefs(html_map) {
	{com {Plain} 0 {<MAP NAME=></MAP>} {command {insert coms html(map.main)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18n} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_area) {
	{com {Area} 0 {<AREA ALT=>} {command {insert coms html(area.main)}}}
	{com {Shape} 0 {+ SHAPE=} {command {insert coms html(area.shape)}}}
	{com {Coords} 0 {+ COORDS=} {command {insert coms html(area.coords)}}}
	{com {Href} 0 {+ HREF=} {command {insert coms html(area.href)}}}
	{com {No ref} 0 {+ NOREF} {command {insert coms html(area.noref)}}}
	{com {Tab index} 0 {+ TABINDEX=} {command {insert coms html(area.tabindex)}}}
	{com {Access key} 0 {+ ACCESSKEY=} {command {insert coms html(area.accesskey)}}}
	{com {On focus} 0 {+ ONFOCUS=} {command {insert coms html(area.onfocus)}}}
	{com {On blur} 0 {+ ONBLUR=} {command {insert coms html(area.onblur)}}}
}

set html_menudefs(html_frames) {
	{sub {Frame set} 0 html_frameset}
	{sub {Frame} 0 html_frame}
	{sub {No frames} 0 html_noframes}
	{sub {Inline frames} 0 html_iframe}
}

set html_menudefs(html_frameset) {
	{com {Frame set} 0 {<FRAMESET> </FRAMESET>} {command {insert coms html(frameset.main)}}}
	{}
	{com {Rows} 0 {+ ROWS=} {command {insert coms html(frameset.rows)}}}
	{com {Columns} 0 {+ COLS=} {command {insert coms html(frameset.cols)}}}
	{com {On load} 0 {+ ONLOAD=} {command {insert coms html(frameset.onload)}}}
	{com {On unload} 0 {+ ONUNLOAD=} {command {insert coms html(frameset.onunload)}}}
	{sub {Core attributes} 0 html_coreattrs}
}

set html_menudefs(html_frame) {
	{com {Frame} 0 {<FRAME>} {command {insert coms html(frame.main)}}}
	{}
	{com {Long desc} 0 {+ LONGDESC=} {command {insert coms html(frame.longdesc)}}}
	{com {Name} 0 {+ NAME=} {command {insert coms html(frame.name)}}}
	{com {Source} 0 {+ SRC=} {command {insert coms html(frame.src)}}}
	{com {Frame border} 0 {+ FRAMEBORDER=} {command {insert coms html(frame.frameborder)}}}
	{com {Margin width} 0 {+ MARGINWIDTH=} {command {insert coms html(frame.width)}}}
	{com {Margin height} 0 {+ MARGINHEIGHT=} {command {insert coms html(frame.height)}}}
	{com {Scrolling} 0 {+ SCROLLING=} {command {insert coms html(frame.scroll)}}}
	{com {No resize} 0 {+ NORESIZE} {command {insert coms html(frame.resize)}}}
	{sub {Core attributes} 0 html_coreattrs}
}

set html_menudefs(html_noframes) {
	{com {No frames} 0 {<NOFRAMES> </NOFRAMES>} {command {insert coms html(noframes.main)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_iframe) {
	{com {Inline frame} 0 {<IFRAMESET> </FRAMESET>} {command {insert coms html(iframe.main)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{com {Long desc} 0 {+ LONGDESC=} {command {insert coms html(iframe.longdesc)}}}
	{com {Name} 0 {+ NAME=} {command {insert coms html(iframe.name)}}}
	{com {Source} 0 {+ SRC=} {command {insert coms html(iframe.src)}}}
	{com {Frame border} 0 {+ FRAMEBORDER=} {command {insert coms html(iframe.frameborder)}}}
	{com {Margin width} 0 {+ MARGINWIDTH=} {command {insert coms html(iframe.width)}}}
	{com {Margin height} 0 {+ MARGINHEIGHT=} {command {insert coms html(iframe.height)}}}
	{com {Scrolling} 0 {+ SCROLLING=} {command {insert coms html(frame.scroll)}}}
	{com {Align} 0 {+ NORESIZE} {command {insert coms html(iframe.align)}}}
	{com {Width} 0 {+ WIDTH=} {command {insert coms html(iframe.width)}}}
	{com {Height} 0 {+ HEIGHT=} {command {insert coms html(iframe.height)}}}
}

set html_menudefs(html_forms) {
	{sub {Forms} 0 html_form}
	{sub {Input} 0 html_input}
	{sub {Button} 0 html_button}
	{sub {Select} 0 html_select}
	{sub {Option group} 0 html_optgrp}
	{sub {Option} 0 html_option}
	{sub {Text area} 0 html_texta}
	{sub {Label} 0 html_label}
	{sub {Fieldset} 0 html_fieldset}
	{sub {Legend} 0 html_legend}
}

set html_menudefs(html_form) {
	{com {Form element} 0 {<FORM ACTION=> </FORM>} {command {insert coms html(form.main)}}}
	{}
	{com {Method} 0 {+ METHOD=} {command {insert coms html(form.method)}}}
	{com {Content type} 0 {+ ENCTYPE=} {command {insert coms html(form.enctype)}}}
	{com {Content type list} 0 {+ ACCEPT=} {command {insert coms html(form.accept)}}}
	{com {Name} 0 {+ NAME=} {command {insert coms html(form.name)}}}
	{com {On submit} 0 {+ ONSUBMIT=} {command {insert coms html(form.onsubmit)}}}
	{com {On reset} 0 {+ ONRESET=} {command {insert coms html(form.onreset)}}}
	{com {Charsets} 0 {+ ACCEPT-CHARSET=} {command {insert coms html(form.charset)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_input) {
	{com {Input} 0 {<INPUT>} {command {insert coms html(input.main)}}}
	{}
	{com {Type} 0 {+ TYPE=} {command {insert coms html(input.type)}}}
	{com {Name} 0 {+ NAME=} {command {insert coms html(input.name)}}}
	{com {Value} 0 {+ VALUE=} {command {insert coms html(input.value)}}}
	{com {Checked} 0 {+ CHECKED} {command {insert coms html(input.checked)}}}
	{com {Disabled} 0 {+ DISABLED} {command {insert coms html(input.disabled)}}}
	{com {Read only} 0 {+ READONLY} {command {insert coms html(input.readonly)}}}
	{com {Size} 0 {+ SIZE=} {command {insert coms html(input.size)}}}
	{com {Max length} 0 {+ MAXLENGTH=} {command {insert coms html(input.maxlength)}}}
	{com {Src} 0 {+ SRC=} {command {insert coms html(input.src)}}}
	{com {Alt} 0 {+ ALT=} {command {insert coms html(input.alt)}}}
	{com {Client img} 0 {+ USEMAP=} {command {insert coms html(input.usemap)}}}
	{com {Server img} 0 {+ ISMAP} {command {insert coms html(input.ismap)}}}
	{com {Tab index} 0 {+ TABINDEX=} {command {insert coms html(input.tabindex)}}}
	{com {Access key} 0 {+ ACCESSKEY=} {command {insert coms html(input.accesskey)}}}
	{com {On focus} 0 {+ ONFOCUS=} {command {insert coms html(input.onfocus)}}}
	{com {On blur} 0 {+ ONBLUR=} {command {insert coms html(input.onblur)}}}
	{com {On select} 0 {+ ONSELECT=} {command {insert coms html(input.onselect)}}}
	{com {On change} 0 {+ ONCHANGE=} {command {insert coms html(input.onchange)}}}
	{com {Accept} 0 {+ ACCEPT=} {command {insert coms html(input.accept)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_button) {
	{com {Button element} 0 {<BUTTON> </BUTTON>} {command {insert coms html(button.main)}}}
	{}
	{com {Name} 0 {+ NAME=} {command {insert coms html(button.name)}}}
	{com {Value} 0 {+ VALUE=} {command {insert coms html(button.value)}}}
	{com {Type} 0 {+ TYPE=} {command {insert coms html(button.type)}}}
	{com {Disabled} 0 {+ DISABLED} {command {insert coms html(button.disabled)}}}
	{com {Tab index} 0 {+ TABINDEX=} {command {insert coms html(button.tabindex)}}}
	{com {Access key} 0 {+ ACCESSKEY=} {command {insert coms html(button.accesskey)}}}
	{com {On focus} 0 {+ ONFOCUS=} {command {insert coms html(button.onfocus)}}}
	{com {On blur} 0 {+ ONBLUR=} {command {insert coms html(button.onblur)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_select) {
	{com {Button element} 0 {<SELECT> </SELECT>} {command {insert coms html(select.main)}}}
	{}
	{com {Name} 0 {+ NAME=} {command {insert coms html(select.name)}}}
	{com {Size} 0 {+ SIZE=} {command {insert coms html(select.value)}}}
	{com {Multiple} 0 {+ MULTIPLE} {command {insert coms html(select.type)}}}
	{com {Disabled} 0 {+ DISABLED} {command {insert coms html(select.disabled)}}}
	{com {Tab index} 0 {+ TABINDEX=} {command {insert coms html(select.tabindex)}}}
	{com {On focus} 0 {+ ONFOCUS=} {command {insert coms html(select.onfocus)}}}
	{com {On blur} 0 {+ ONBLUR=} {command {insert coms html(select.onblur)}}}
	{com {On change} 0 {+ ONCHANGE=} {command {insert coms html(select.change)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_optgrp) {
	{com {Button element} 0 {<OPTGROUP LABEL=> </OPTGROUP>} {command {insert coms html(optgrp.main)}}}
	{}
	{com {Disabled} 0 {+ DISABLED} {command {insert coms html(optgrp.disabled)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_option) {
	{com {Button element} 0 {<OPTION></OPTION>} {command {insert coms html(option.main)}}}
	{}
	{com {Selected} 0 {+ SELECTED} {command {insert coms html(option.selected)}}}
	{com {Disabled} 0 {+ DISABLED} {command {insert coms html(option.disabled)}}}
	{com {Label} 0 {+ LABEL=} {command {insert coms html(option.label)}}}
	{com {Value} 0 {+ VALUE=} {command {insert coms html(option.value)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_texta) {
	{com {Text area} 0 {<TEXTA ..> </TEXTA>} {command {insert coms html(texta.main)}}}
	{}
	{com {Name} 0 {+ NAME=} {command {insert coms html(texta.name)}}}
	{com {Disabled} 0 {+ DISABLED} {command {insert coms html(texta.disabled)}}}
	{com {Read only} 0 {+ READONLY} {command {insert coms html(texta.readonly)}}}
	{com {Tab index} 0 {+ TABINDEX=} {command {insert coms html(texta.tabindex)}}}
	{com {Access key} 0 {+ ACCESSKEY=} {command {insert coms html(texta.accesskey)}}}
	{com {On focus} 0 {+ ONFOCUS=} {command {insert coms html(texta.onfocus)}}}
	{com {On blur} 0 {+ ONBLUR=} {command {insert coms html(texta.onblur)}}}
	{com {On select} 0 {+ ONSELECT=} {command {insert coms html(texta.onselect)}}}
	{com {On change} 0 {+ ONCHANGE=} {command {insert coms html(texta.onchange)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_label) {
	{com {Text area} 0 {<LABEL></LABEL>} {command {insert coms html(label.main)}}}
	{}
	{com {For} 0 {+ FOR=} {command {insert coms html(label.for)}}}
	{com {Access key} 0 {+ ACCESSKEY=} {command {insert coms html(label.accesskey)}}}
	{com {On focus} 0 {+ ONFOCUS=} {command {insert coms html(label.onfocus)}}}
	{com {On blur} 0 {+ ONBLUR=} {command {insert coms html(label.onblur)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}


set html_menudefs(html_fieldset) {
	{com {Text area} 0 {<FIELDSET> </FIELDSET>} {command {insert coms html(fieldset.main)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_legend) {
	{com {Legend} 0 {<LEGEND></LEGEND>} {command {insert coms html(legend.main)}}}
	{}
	{com {Access key} 0 {+ ACCESSKEY=} {command {insert coms html(legend.accesskey)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_scripts) {
	{sub {Script} 0 html_script}
	{sub {No script} 0 html_noscript}
	{sub {Hiding script} 0 html_hide}
}

set html_menudefs(html_script) {
	{com {Script} 0 {<SCRIPT TYPE=> </SCRIPT>} {command {insert coms html(script.main)}}}
	{}
	{com {Charset} 0 {+ CHARSET=} {command {insert coms html(script.charset)}}}
	{com {Source} 0 {+ SRC=} {command {insert coms html(script.src)}}}
	{com {Defer} 0 {+ DEFER} {command {insert coms html(script.defer)}}}
}

set html_menudefs(html_noscript) {
	{com {Script} 0 {<NOSCRIPT TYPE=> </NOSCRIPT>} {command {insert coms html(noscript.main)}}}
	{}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set html_menudefs(html_hide) {
	{com {General} 0 {<!-- -->} {command {insert coms html(hide.general)}}}
	{com {Java} 0 {<!-- // -->} {command {insert coms html(hide.java)}}}
	{com {Tcl} 0 {<!-- # -->} {command {insert coms html(hide.tcl)}}}
}


set menumult(html_coreattrs) {yes}
set html_menudefs(html_coreattrs) {
	{com {Id} 0 {+ ID=} {command {insert coms html(coreattrs.id)}}}
	{com {Class} 0 {+ CLASS=} {command {insert coms html(coreattrs.class)}}}
	{com {Style} 0 {+ STYLE=} {command {insert coms html(coreattrs.style)}}}
	{com {Title} 0 {+ TITLE=} {command {insert coms html(coreattrs.title)}}}
}

set menumult(html_i18n) {yes}
set html_menudefs(html_i18n) {
	{com {Language} 0 {+ LANG=} {command {insert coms html(i18n.lang)}}}
	{com {Direction} 0 {+ DIR=} {command {insert coms html(i18n.dir)}}}
}

set menumult(html_events) {yes}
set html_menudefs(html_events) {
	{com {On click} 0 {+ ONCLICK=} {command {insert coms html(events.click)}}}
	{com {On bouble click} 0 {+ ONDBLCLICK=} {command {insert coms html(events.dblclick)}}}
	{com {On mouse down} 0 {+ ONMOUSEDOWN=} {command {insert coms html(events.mousedown)}}}
	{com {On mouse up} 0 {+ ONMOUSEUP=} {command {insert coms html(events.mouseup)}}}
	{com {On mouse over} 0 {+ ONMOUSEOVER=} {command {insert coms html(events.mouseover)}}}
	{com {On mouse out} 0 {+ ONMOUSEOUT=} {command {insert coms html(events.mouseout)}}}
	{com {On mouse move} 0 {+ ONMOUSEMOVE=} {command {insert coms html(events.mousemove)}}}
	{com {On key press} 0 {+ ONKEYPRESS=} {command {insert coms html(events.keypress)}}}
	{com {On key down} 0 {+ ONKEYDOWN=} {command {insert coms html(events.keydown)}}}
	{com {On key up} 0 {+ ONKEYUP=} {command {insert coms html(events.keyup)}}}
}

set menumult(html_object) {yes}
set html_menudefs(html_object) {
	{com {Object} 0 {<OBJECT> </OBJECT>} {command {insert coms html(object.main)}}}
	{}
	{com {Declare only} 0 {+ DECLARE} {command {insert coms html(object.declare)}}}
	{com {Class id} 0 {+ CLASSID=} {command {insert coms html(object.classid)}}}
	{com {Code base} 0 {+ CODEBASE=} {command {insert coms html(object.codebase)}}}
	{com {Data} 0 {+ DATA=} {command {insert coms html(object.data)}}}
	{com {Type for data} 0 {+ TYPE=} {command {insert coms html(object.type)}}}
	{com {Type for code} 0 {+ CODETYPE=} {command {insert coms html(object.codetype)}}}
	{com {Archive} 0 {+ ARCHIVE=} {command {insert coms html(object.archive)}}}
	{com {Loading message} 0 {+ STANDBY=} {command {insert coms html(object.standby)}}}
	{com {Height} 0 {+ HEIGHT=} {command {insert coms html(object.height)}}}
	{com {Width} 0 {+ WIDTH=} {command {insert coms html(object.width)}}}
	{com {Client image map} 0 {+ USEMAP=} {command {insert coms html(object.usemap)}}}
	{com {Name} 0 {+ NAME=} {command {insert coms html(object.name)}}}
	{com {Tab index} 0 {+ TABINDEX=} {command {insert coms html(object.tabindex)}}}
	{sub {Core attributes} 0 html_coreattrs}
	{sub {i18} 0 html_i18n}
	{sub {Events} 0 html_events}
}

set menumult(html_align) {yes}
set html_menudefs(html_align) {
	{com {Alignment} 0 {+ ALIGN=} {command {insert coms html(align.align)}}}
	{com {Alignment char} 0 {+ CHAR=} {command {insert coms html(align.char)}}}
	{com {Offset} 0 {+ OFFSET=} {command {insert coms html(align.offset)}}}
	{com {Vert align} 0 {+ VALIGN=} {command {insert coms html(align.valign)}}}
}
proc html_makemenu {menu defs} {
	global	menumult html_menudefs options

	menu $menu -tearoff 1 -font -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*
	foreach mitem $html_menudefs($defs) {
		if {!$options(global.accelerators)} {
			set accel {}
		} else {
			set accel [lindex $mitem 3]
		}
		switch [lindex $mitem 0] {
			{}	{
				$menu add separator
			}
			com	{
				$menu add command -label [lindex $mitem 1] -underline [lindex $mitem 2] -accelerator $accel -command [lindex $mitem 4]
			}
			check	{
				$menu add checkbutton -label [lindex $mitem 1] -variable [lindex $mitem 2] -command [lindex $mitem 3]
			}
			radio	{
				$menu add radiobutton -label [lindex $mitem 1] -variable [lindex $mitem 2] -value [lindex $mitem 3]
			}
			sub	{
				html_makemenu $menu.[lindex $mitem 3] [lindex $mitem 3]
				$menu add cascade -label [lindex $mitem 1] -menu $menu.[lindex $mitem 3] -underline [lindex $mitem 2]
			}
		}
	}
	if {![info exists menumult($defs)]} {
		unset html_menudefs($defs)
	}
}

proc html_makemenus {} {
	global	menu html_menudefs
	set mn "html"
	menubutton .m.$mn -text "HTML" -underline 1 -menu .m.$mn.m -font -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*
	html_makemenu .m.$mn.m $mn
	pack .m.$mn -side left
	pack .m -side top -fill x
}
