
proc play_comlist {var} {

	set coms [uplevel #0 set $var]

	if {[llength $coms] == 0} {
		return
	}
	foreach com $coms {
		set macro(play) 1
		command $com
	}
	set macro(play) 0
}

proc macro_start {name} {
	global tkPriv	macros macro

	if {$macro(rec)} {
		showinfo "Macro record allready running!"
		return
	}
	if {$name == {}} {
		if {[input_panel .mex {macro record start} {Macro name} 10 {} [array names macros]]} {
			if {[set name [string trim $tkPriv(input)]] != {}} {
				command "macro start $name"
			}
		}
		return
	}
	if {![regexp {[A-Za-z0-9_]*} $name]} {
		showinfo "Macro name <$name> not allowed!"
		return
	}
	set macro(rec)	1
	set macro(name)	$name
	set macro(last) {}
	set macros($name)	{}
	showinfo "Start recording macro <$macro(name)>."
}

proc macro_stop {} {
	global	macro

	if {$macro(name) != {}} {
		showinfo "Stop recording macro <$macro(name)>."
		set macro(rec)	0
		set macro(name)	{}
	} else {
		showinfo "No macro recording to stop."
	}
}


proc macro_exec {name} {
	global	tkPriv macros macro

	if {$name == {}} {
		if {[input_panel .mex {macro execute} Macro 10 {} [array names macros]]} {
			if {[set name [string trim $tkPriv(input)]] != {}} {
				command "macro exec $name"
			}
		}
		return
	}
	if {![regexp {[A-Za-z0-9_]*} $name]} {
		showinfo "Macro name <$name> not allowed!"
		return
	}
	if {[lsearch -exact [array names macros] $name] != -1} {
		showinfo "Execute macro <$name>."
		foreach com $macros($name) {
			set macro(play) 1
			command $com
		}
		set macro(play) 0
	} else {
		showinfo "Macro <$name> not defined."
	}
}

proc macros_save {} {
	global env macros

	showinfo "Saving macros in <$env(HOME)/.eddi/macros> ..."
	set f [open $env(HOME)/.eddi/macros w]
	foreach opt [array names macros] {
		puts $f "set macros\($opt) \{$macros($opt)\}"
	}
	close $f
	showinfo "Saving macros in <$env(HOME)/.eddi/macros> ... done."
}

proc macros_load {} {
	global env

	showinfo "Loading macros from <$env(HOME)/.eddi/macros> ..."
	if {[file exists $env(HOME)/.eddi/macros]} {
		uplevel #0 {source $env(HOME)/.eddi/macros}
	}
	showinfo "Loading macros from <$env(HOME)/.eddi/macros> ... done."
}

proc macro_wrap {} {
	global macro

	if {$macro(rec)} {
		if {$macro(wrap)} {
			showinfo {Record next command as usual.}
			set macro(wrap) 0
		} else {
			showinfo {Wrapping next command from recording!}
			set macro(wrap) 1
		}
	} else {
		showinfo {No macro recording started!}
	}
}
