
tixBalloon .balloon -initwait 1000

proc balloon_set {args} {
	global	options

	if {$options(global.showballoon)} {
		.balloon configure -state balloon
	} else {
		.balloon configure -state none
	}
}

balloon_set $options(global.showballoon)

proc showhelp {helptext} {
	global	options manpid program

	set manips {}
	if {$options(global.forceownman)} {
		if {$manpid == 0} {
			showinfo {Try to spawn tkman ...}
			catch {set manpid [exec tkman &]}
			after 500
		}
		foreach ips [winfo interps] {
			if {[string range $ips 0 4] == {tkman}} {
				catch {set id [send $ips pid]}
				if {$id == $manpid} {
					set manips $ips
					break
				}
			}
		}
	}
	if {$manips == {}} {
		if {$options(global.forceownman)} {
			showinfo {Spawn failed, try to find existing tkman ...}
			after 500
		}
		foreach ips [winfo interps] {
			if {[string range $ips 0 4] == {tkman}} {
				set manips $ips
				break
			}
		}
	}
	if {$manips != {}} {
		showinfo "Found $manips ..."
		catch {send $manips "set manx(typein.man) $helptext"}
		catch {send $manips {.man.man invoke}}
		showinfo "Requested help for '$helptext'."
	} else {
		showinfo {Can't find any tkman, spawning xterm ...}
		catch {exec xterm -T "$program(name) V$program(version): man" -n "$program(name): man" -e man -a $helptext &}
		after 500
		showinfo {Spawning xterm ... done.}
	}
}
proc browser_select {} {
	global tkPriv programs

	if {[input_panel .browsersel {Configure browser} {Browser command:} 15 $programs(html) {mozilla galeon netscape opera konqueror "xterm -e w3m" "xterm -e lynx" "xterm -e links" arena}]} {
                if {[string trim $tkPriv(input)] != {}} {
                        set programs(html) [string trim $tkPriv(input)]
                }
        }
}
									
proc aboutbox {} {
  global program ownpath

  toplevel .about
  wm title .about "About $program(name)"

  frame .about.top

  message .about.top.msg1 -width 400 -justify c -bg "#FFFFFF"\
    -text "\n$program(name) $program(version)\n" -font {-adobe-helvetica-bold-r-*-*-16-*-*-*-*-*-*-*}
  pack .about.top -side top -expand 1 -fill both

  image create photo Eddilogo -format gif -file \
    [file join $ownpath icons logo.gif]
  label .about.top.lbl -image Eddilogo -bg "#FFFFFF"

  append prj_string "The friendly editor.\n"
  append prj_string "Consult the Help menu to\n"
  append prj_string "learn about its features.\n\n"
  append prj_string "Eddi was written by Holger Schanz.\n"

  message .about.top.msg2 -width 400 -justify c -bg "#FFFFFF"\
    -text $prj_string

  append about_string "\nFrom version 0.10.1 maintained by the Eddi project\n"
  append about_string "Home page: http://eddi.sourceforge.net/\n"
  append about_string "Source code: http://sourceforge.net/projects/eddi/\n"

  message .about.top.msg3 -width 365 -justify c -bg "#EED1B9"\
    -text $about_string -font {-adobe-helvetica-medium-r-*-*-14-*-*-*-*-*-*-*}

  pack .about.top -side top -expand 1 -fill both
  pack .about.top.msg1 -expand 1 -fill x
  pack .about.top.lbl
  pack .about.top.msg2 -expand 1 -fill x
  pack .about.top.msg3 -expand 1 -fill x

  frame .about.down
  button .about.down.ok -text "OK" -command {destroy .about}

  pack .about.down -side bottom -expand 1 -fill x -pady 2
  pack .about.down.ok
}

proc extension {name} {
	return [string range [file extension $name] 1 end]
}

proc getraised {} {
	return [.nb raised]
}

proc setfocus {} {
	global macro

	set fn [getraised]
	set f [twidgetbyno $fn]
	if {!$macro(play)} {
		update idletasks
	}
	focus $f
}

proc setmodified {no m} {
	global	modified

	set modified($no) $m
	if {$m} {
		if {[lsearch [.nb pages] $no] != -1} {
			.nb pageconfigure $no -underline 0
		}
	} else {
		if {[lsearch [.nb pages] $no] != -1} {
			.nb pageconfigure $no -underline -1
		}
	}
}

proc showposition {w} {
	global	xpos ypos
	scan [$w index insert] "%d.%d" ypos xpos
	incr xpos
}

proc getraiseno {args} {
	global	fno modified xpos ypos modes fmode mode macro fopts fileopts program project filename

	set fno [getraised]
	set f [twidgetbyno $fno]
	set s $mode($fno)
	if {[winfo exists $f] == 0} {
		return
	}
	scan [$f index insert] {%d.%d} ypos xpos
	incr xpos
	set fmode $mode($fno)
	foreach opt {autoindent bracefind useefi showbms} {
		if {[lsearch [array names fileopts $fno.*] $fno.$opt] != -1} {
			uplevel #0 set f$opt $fileopts($fno.$opt)
		}
	}

	setfocus
	if {$project(name) != {}} {
		set prjname "([file tail $project(name)])"
	} else {
		set prjname {}
	}
	if {[lsearch [array names filename] $fno] != -1 && $filename($fno) != {}} {
		wm title . "$program(name): [file nativename $filename($fno)] $prjname"
		wm iconname . "$program(name): [file tail $filename($fno)] $prjname"
	}
	if {!$macro(play)} {
		update idletasks
	}
	if {$s == "HTML"} {
		if {[winfo exists .m.html]} {
			pack .m.html -side left
		} else {
			html_makemenus
		}
	}
	if {$s != "HTML"} {
		# control if the html menu is available and if so, remove it.
		if {[winfo exists .m.html]} {
			pack forget .m.html
		}
	}

}

proc delinfo {no} {
	global	info macro

	if {$no == $info(no)} {
		set info(text) {}
		if {!$macro(play)} {
			update idletasks
		}
	}
}

proc showinfo {text} {
	global	info macro

	set info(text) $text
	set no [incr info(no)]
	if {!$macro(play)} {
		update idletasks
	}
	after 10000 delinfo $no
}

proc rpos {pos1 op pos2} {
	scan $pos1 "%d.%d" y1 x1
	scan $pos2 "%d.%d" y2 x2
	eval set e [expr $y1 $op $y2]
	if {$e} {
		if {$y1 == $y2} {
			eval return [expr $x1 $op $x2]
		} else {
			return 1
		}
	} else {
		if {$y1 == $y2} {
			eval return [expr $x1 $op $x2]
		} else {
			return 0
		}
	}
}

proc load_words {} {
	global	words chset ownpath

	set type {}
	set col {}
	set f [open $ownpath/words r]
	while {[gets $f line] > 0} {
		if {[lindex $line 0] == {#MODE}} {
			set type [lindex $line 1]
		} elseif {[lindex $line 0] == {#TAG}} {
			set col [lindex $line 1]
			set chset($type.$col) {}
		} else {
			set ch [string range $line 0 0]
			append chset($type.$col) $ch
			set words($type.$col.$ch) $line
		}
	}
}

proc nobyname {name} {
	global	files filename

	for {set i 0} {$i < $files} {incr i} {
		if {[file tail $filename($i)] == [file tail $name]} {
			return $i
		}
	}
	return -1
}

proc widgetbyno {no} {
	return .nb.nbframe.$no
}

proc twidgetbyno {no} {
	return .nb.nbframe.$no.t
}

proc nobytwidget {name} {
	return [extension [file rootname $name]]
}

proc completename {name} {
	if {[string range $name 0 0] == {/}} {
		return $name
	} else {
		if {[file dirname $name] == {.}} {
			return [pwd]/[file tail $name]
		} else {
			return [pwd]/$name
		}
	}
}

proc input_panel {w title label width init choice} {
	global	program tkPriv

	set tkPriv(input_panel) $w
	set tkPriv(input) $init
	catch {destroy $w}
	toplevel $w
	wm title $w "$program(name): $title"
	wm iconname $w "$program(name)"

	frame $w.t -bd 1 -relief raised
	tixComboBox $w.t.cb -label $label -dropdown true -editable true \
		-variable tkPriv(input) -selectmode immediate -options "
			listbox.height 6
			label.width [expr [string length $label]+3]
			label.anchor e
			entry.width $width
		"
	[$w.t.cb subwidget listbox] configure -exportselection false
	foreach entry $choice {
		if {[string trim $entry] != {}} {
			$w.t.cb insert end $entry
		}
	}
	pack $w.t.cb -side left -padx 10 -pady 5 -fill x -expand yes
	frame $w.b -bd 1 -relief raised
	button $w.b.ok -text Ok -command {set tkPriv(button) 1}
	button $w.b.cancel -text Cancel -command {set tkPriv(button) 0}
	pack $w.b.ok $w.b.cancel -side left -padx 10 -pady 5 -fill x -expand yes
	pack $w.t $w.b -side top -fill x -expand yes
	update idletasks
	bind $w <Destroy> {set tkPriv(button) 0}
	bind $w <Return> "
		$w.b.ok configure -state active -relief sunken
		update idletasks
		after 100
		set tkPriv(button) 1
	"
	bind $w <Escape> "
		$w.b.cancel configure -state active -relief sunken
		update idletasks
		after 100
		set tkPriv(button) 0
	"
	set oldfocus [focus]
	focus [$w.t.cb subwidget entry]
	tkwait variable tkPriv(button)
	catch {focus $oldfocus}
	catch {
		bind $w <Destroy> {}
		destroy $w
	}
	return $tkPriv(button)
}
