
proc options_save {} {
	global options env programs
	catch {exec mkdir $env(HOME)/.eddi}
	set f [open $env(HOME)/.eddi/options w]
	foreach opt [array names options] {
		puts $f "set options\($opt) \{$options($opt)\}"
	}
	close $f

	set f [open $env(HOME)/.eddi/programs w]
        foreach opt [array names programs] {
                puts $f "set programs\($opt) \{$programs($opt)\}"
       }
       close $f
					      
}
									
proc tag_panel_setstate {var name state} {
	global	tagedit

	set w $tagedit($var.panel)
	set tagedit($var.$name) $state
	foreach e [winfo children $w.t.$name.f] {
		$e configure -state $state
	}
}

proc tag_panel_getvals {var} {
	global	options tagedit tagsdefs fileefi

	set idx $tagedit($var.idx)
	set tagedit($var.tag) [set tag [lindex $tagedit($var.tagopts) $idx]]
	set optvar $tagedit($var.optvar)
	set prefix $tagedit($var.prefix)
	foreach tlist $tagsdefs {
		set name [lindex $tlist 0]
		if {[lsearch $tagedit($var.optlist) $name] == -1} continue
		set opt $optvar\($prefix.$tag.$name\)
		if {[info exists $opt]} {
			set tagedit($var.$name) normal
			tag_panel_setstate $var $name normal
			eval set tagedit($var.val.$name) \$$opt
		} else {
			tag_panel_setstate $var $name disabled
			set tagedit($var.val.$name) {}
		}
	}
}

proc tag_panel_setvals {var} {
	global	options tagedit tagsdefs fileefi

	if {$tagedit($var.fno) != {}} {
		setmodified $tagedit($var.fno) 1
	}
	set w $tagedit($var.panel)
	set idx $tagedit($var.idx)
	if {$idx == {}} return
	set tag [lindex $tagedit($var.tagopts) $idx]
	set optvar $tagedit($var.optvar)
	set prefix $tagedit($var.prefix)
	if {$tagedit($var.name) == {}} {
		set tagedit($var.name) $tagedit($var.tag)
	}
	set $optvar\($prefix.$tag.info\) $tagedit($var.name)
	$w.l.tl.l delete $idx
	$w.l.tl.l insert $idx $tagedit($var.name)
	$w.l.tl.l selection clear 0 end
	$w.l.tl.l selection set $idx
	foreach tlist $tagsdefs {
		set name [lindex $tlist 0]
		if {[lsearch $tagedit($var.optlist) $name] == -1} continue
		set opt $optvar\($prefix.$tag.$name\)
		set $opt $tagedit($var.val.$name)
		if {$tagedit($var.$name) == {disabled}} {
			unset $opt
		}
	}
}

proc tag_panel_addval {var} {
	global	options tagedit tagsdefs fileefi

	if {$tagedit($var.fno) != {}} {
		setmodified $tagedit($var.fno) 1
	}
	set w $tagedit($var.panel)
	set tagedit($var.idx) [set idx [$w.l.tl.l size]]
	set optvar $tagedit($var.optvar)
	set prefix $tagedit($var.prefix)
	set taglists $tagedit($var.taglists)
	if {$idx == {} || $tagedit($var.tag) == {}} return
	if {$tagedit($var.name) == {}} {
		set tagedit($var.name) $tagedit($var.tag)
	}
	set tag $tagedit($var.tag)
	set opt $optvar\($taglists\)
	eval set list \$$opt
	set p [lsearch $list $tag]
	if {$p != -1} return
	set tagedit($var.tagopts) [lappend $opt $tag]
	set $optvar\($prefix.$tag.info\) $tagedit($var.name)
	$w.l.tl.l insert $idx $tagedit($var.name)
	$w.l.tl.l selection clear 0 end
	$w.l.tl.l selection set $idx
	foreach tlist $tagsdefs {
		set name [lindex $tlist 0]
		if {[lsearch $tagedit($var.optlist) $name] == -1} continue
		set opt $optvar\($prefix.$tag.$name\)
		set $opt $tagedit($var.val.$name)
		if {$tagedit($var.$name) == {disabled}} {
			unset $opt
		}
	}
}

proc tag_panel_delval {var} {
	global	options tagedit tagsdefs fileefi

	if {$tagedit($var.fno) != {}} {
		setmodified $tagedit($var.fno) 1
	}
	set w $tagedit($var.panel)
	set idx $tagedit($var.idx)
	set optvar $tagedit($var.optvar)
	set prefix $tagedit($var.prefix)
	set taglists $tagedit($var.taglists)
	if {$idx == {}} return
	set tag [lindex $tagedit($var.tagopts) $idx]
	set opt $optvar\($taglists\)
	eval set list \$$opt
	set p [lsearch $list $tag]
	if {$p == -1} return
	set tagedit($var.tagopts) [set $opt "[lrange $list 0 [expr $p-1]] [lrange $list [expr $p+1] end]"]
	$w.l.tl.l delete $idx
	$w.l.tl.l selection clear 0 end
	set tagedit($var.idx) {}
	foreach opt [array names options $prefix.$tag.*] {
		unset options($opt)
	}
}

proc tag_options_panel {title var mod optvar prefix taglists optlist} {
	global	program options tagsdefs fileefi tagedit fno

	set w .$optvar
	set tagopts {}
	foreach list $taglists {
		eval set tlist \$$optvar\($list\)
		foreach tag $tlist {
			lappend tagopts $tag
		}
	}
	set tagedit($var.taglists) $taglists
	set tagedit($var.tagopts) $tagopts
	set tagedit($var.optlist) $optlist
	set tagedit($var.optvar) $optvar
	append prefix tag
	set tagedit($var.prefix) $prefix
	set tagedit($var.mod) $mod
	set tagedit($var.panel) $w
	set tagedit($var.idx) {}
	set tagedit($var.fno) {}
	set tagedit($var.name) {}
	set tagedit($var.tag) {}
	set tagedit($var.ok) {}
	if {$optvar == {fileefi}} {
		set tagedit($var.fno) $fno
	}

	catch {destroy $w}
	toplevel $w
	wm title $w "$program(name): $title"
	wm iconname $w "$program(name)"
	frame $w.b -bd 1 -relief raised
	button $w.b.done -text Done -command "set tagedit($var.ok) 1"
	pack $w.b.done -side left -padx 10 -pady 5 -fill x -expand yes
	pack $w.b -side bottom -expand yes -fill x
	frame $w.l -bd 1 -relief raised
	label $w.l.lname -text "Tag info:"
	entry $w.l.name -textvariable tagedit($var.name) -width 10 -state $mod
	label $w.l.ltag -text "Tag name:"
	entry $w.l.tag -textvariable tagedit($var.tag) -width 10 -state $mod
	frame $w.l.tl
	listbox $w.l.tl.l -width 10 -selectmode single -yscrollcommand "$w.l.tl.s set"
	bind $w.l.tl.l <1> "
		set tagedit($var.name) \[%W get @%x,%y\]
		set tagedit($var.idx) \[%W index @%x,%y\]
		tag_panel_getvals $var 
	"
	foreach tag $tagopts {
		eval $w.l.tl.l insert end \$$optvar\($prefix.$tag.info\)
	}
	scrollbar $w.l.tl.s -command "$w.l.tl.l yview"
	pack $w.l.tl.s -side right -expand yes -fill y
	pack $w.l.tl.l -side left -expand yes -fill both
	pack $w.l.lname $w.l.name $w.l.ltag $w.l.tag -side top -fill x -padx 5
	pack $w.l.tl -side top -expand yes -fill both -padx 5 -pady 10
	button $w.l.new -text New -state $mod -command "tag_panel_addval $var"
	button $w.l.del -text Delete -state $mod -command "tag_panel_delval $var"
	button $w.l.set -text Set -command "tag_panel_setvals $var"
	pack $w.l.new $w.l.del $w.l.set -side top -fill x
	pack $w.l -side left -expand yes -fill y
	frame $w.t -bd 1 -relief raised
	foreach tag $tagsdefs {
		set name [lindex $tag 0]
		if {[lsearch $optlist $name] == -1} continue
		set tagedit($var.$name) disabled
		frame $w.t.$name
		checkbutton $w.t.$name.cb -text "[lindex $tag 1]:" -variable tagedit($var.$name) -offvalue disabled -onvalue normal\
			-command "tag_panel_setstate $var $name \$tagedit($var.$name)"
		frame $w.t.$name.f
		set tagedit($var.val.$name) {}
		switch [lindex $tag 2] {
			entry	{
				set tagedit($var.val.$name) {}
				entry $w.t.$name.f.e -textvariable tagedit($var.val.$name) -width [lindex $tag 3] -state disabled -justify right
				pack $w.t.$name.f.e -side left
			}
			radio {
				foreach r [lindex $tag 3] {
					radiobutton $w.t.$name.f.$r -text $r -variable tagedit($var.val.$name) -value $r -state disabled
					pack $w.t.$name.f.$r -side left
				}
			}
		}
		pack $w.t.$name.cb -side left -padx 10
		pack $w.t.$name.f -side right -padx 10 -pady 5
		pack $w.t.$name -side top -expand yes -fill x
	}
	pack $w.t -side top -fill both -expand yes
	update idletasks
	set oldfocus [focus]
	tkwait variable tagedit($var.ok)
	catch {focus $oldfocus}
	catch {
		bind $w <Destroy> {}
		destroy $w
	}
	return $tagedit($var.ok)
}

proc set_eddi_tags {} {
	global	options

	set taglists {color.tags compile.tags}
	set optlist {foreground background border relief underline overstrike offset justify font wrap tabs}
	tag_options_panel {options text preferences} systags disabled options {} $taglists $optlist
}

proc set_user_tags {} {
	global	options

	set taglists {user.tags}
	set optlist {foreground background border relief underline overstrike offset justify font wrap tabs spacing1 spacing2 spacing3 lmargin1 lmargin2 rmargin del}
	tag_options_panel {hypertext global tags} usertags normal options {} $taglists $optlist
}

proc set_file_tags {} {
	global	options fno filename

	set taglists $fno.tags
	set optlist {foreground background border relief underline overstrike offset justify font wrap tabs spacing1 spacing2 spacing3 lmargin1 lmargin2 rmargin del}
	tag_options_panel "hypertext file tags ([file tail $filename($fno)])" filetags normal fileefi $fno. $taglists $optlist
}

proc config_toolbar {} {
	global	options tkPriv

	set oldtoolbar $options($toolbar)
	set w .octb
	catch {destroy $w}
	toplevel $w
	wm title $w "$program(name): options $toolbar"
	wm iconname $w "$program(name)"
	frame $w.t -bd 1 -relief raised
	
	frame $w.b -bd 1 -relief raised
	button $w.b.ok -text Ok -command "set tkPriv($toolbar) 1"
	button $w.b.cancal -text Cancel -command "set tkPriv($toolbar) 0"
	bind $w <Destroy> {set tkPriv($toolbar) 0}
	bind $w <Return> "
		$w.b.ok configure -state active -relief sunken
		update idletasks
		after 100
		set tkPriv($toolbar) 1
	"
	bind $w <Escape> "
		$w.b.cancel configure -state active -relief sunken
		update idletasks
		after 100
		set tkPriv($toolbar) 0
	"
	set oldfocus [focus]
	tkwait variable tkPriv($toolbar)
	if {!$tkPriv($toolbar)} {
		set options($toolbar)
	}
	catch {focus $oldfocus}
	catch {
		bind $w <Destroy> {}
		destroy $w
	}
}
