proc susave_interface { args } {
	global susvar filename fno
	toplevel .susave
	wm title .susave "Eddi SuperSave"
	frame .susave.frame -borderwidth 3 -relief groove
		set tl .susave.frame
		frame ${tl}.left 
		frame ${tl}.right
		button ${tl}.right.ok -command { susa_goforit } -text { OK }
		button ${tl}.right.cancel -command { destroy .susave } -text { Cancel }
		pack ${tl}.right.ok ${tl}.right.cancel -side top -fill both -anchor nw
		frame ${tl}.left.filename
			label ${tl}.left.filename.lb -text "filename: "
			entry ${tl}.left.filename.en -textvariable susvar(filename) -width 20 
			set susvar(filename) $filename($fno)
			button ${tl}.left.filename.bt -text "Browse..." -command { file_dialog {Supersave as } {} {set susvar(filename) } { $susvar(filename) } }
		  pack ${tl}.left.filename.lb ${tl}.left.filename.en ${tl}.left.filename.bt -side left
		frame ${tl}.left.sroot -borderwidth 2 -relief groove
			radiobutton ${tl}.left.sroot.rd -text "Save as root" -variable susvar(who) -value sroot
			  pack ${tl}.left.sroot.rd -side left
		frame ${tl}.left.suser -borderwidth 2 -relief groove
			radiobutton ${tl}.left.suser.rd -text "Save as normal user" -variable susvar(who) -value suser
			frame ${tl}.left.suser.data
				label ${tl}.left.suser.data.ulb -text "  Username: "
				entry ${tl}.left.suser.data.uen -textvariable susvar(username) -width 8
			   grid config ${tl}.left.suser.data.ulb ${tl}.left.suser.data.uen
				checkbutton ${tl}.left.suser.trroot -text "Save through root" -variable susvar(trroot) -offvalue no -onvalue yes
	  		pack ${tl}.left.suser.rd ${tl}.left.suser.data ${tl}.left.suser.trroot -side top -anchor w
				set susvar(who) sroot
		  pack ${tl}.left.filename -side top -anchor n
		  pack ${tl}.left.sroot ${tl}.left.suser -side top -anchor nw -fill both
	pack ${tl}.left ${tl}.right -side left -fill both
	pack .susave.frame -anchor center -side top  -fill both 
	bind .susave <Return> { susa_goforit }
}

proc susa_goforit { } {
	global susvar fno filename 
	set filename($fno) /tmp/.eddi_susave_tmp	
	showinfo "Saving to temporary file..."
	save_file $fno
	showinfo "Saved to temporary file"
	if {$susvar(who) == "sroot"} {
		susa_rootsave $filename($fno)
	}
	if {$susvar(who) == "suser"} {
		susa_usersave $filename($fno)
	}

	set filename($fno) $susvar(filename)
	file delete /tmp/.eddi_susave_tmp
	if {$susvar(succeeded) != ""} {
		showinfo "Supersave failed!"
	} else {
		showinfo "Supersave might have worked ;-)"
	}
	destroy .susave
	
}

proc susa_rootsave { filename } {
	global susvar
	showinfo "Copying to new location using su"
	set susvar(tosucommand) "\"cp -f $filename $susvar(filename)\""
	set susvar(sucommand) "xterm -T \"Enter the password\" -e su -c $susvar(tosucommand)"
	set susvar(succeeded) [eval exec $susvar(sucommand)]
	if {$susvar(succeeded) != ""} {
		showinfo "Copying certainly failed"
		set suvar(succeeded) failed
	}
}

proc susa_usersave { filename } {
	global susvar
	if {$susvar(username) == ""} {
		showinfo "No username defined, Supersave "
	}
	if {$susvar(trroot) == "yes"} {
		set susvar(succeeded) [eval exec "xterm -T \"Enter the password\" -e su -c \"su -c \'cp -f $filename $susvar(filename)\' $susvar(username)\""]
	} else {
		set susvar(succeeded) [eval exec "xterm -T \"Enter the password\" -e su -c \"cp -f $filename $susvar(filename)\" $susvar(username)"]
	}
	
}
