
. config


frame .m -relief raised -bd 1

proc makemenu {menu defs} {
	global	menumult menudefs options

	menu $menu -tearoff 1 -font -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*
	foreach mitem $menudefs($defs) {
		if {!$options(global.accelerators)} {
			set accel {}
		} else {
			set accel [lindex $mitem 3]
		}
		switch [lindex $mitem 0] {
			{}	{
				$menu add separator
			}
			com	{
				$menu add command -label [lindex $mitem 1] -underline [lindex $mitem 2] -accelerator $accel -command [lindex $mitem 4]
			}
			check	{
				$menu add checkbutton -label [lindex $mitem 1] -variable [lindex $mitem 2] -command [lindex $mitem 3]
			}
			radio	{
				$menu add radiobutton -label [lindex $mitem 1] -variable [lindex $mitem 2] -value [lindex $mitem 3]
			}
			sub	{
				makemenu $menu.[lindex $mitem 3] [lindex $mitem 3]
				$menu add cascade -label [lindex $mitem 1] -menu $menu.[lindex $mitem 3] -underline [lindex $mitem 2]
			}
		}
	}
	if {![info exists menumult($defs)]} {
		unset menudefs($defs)
	}
}

proc makemenus {} {
	global	menus menudefs

	foreach menu $menus {
		set mn [lindex $menu 0]
		menubutton .m.$mn -text [lindex $menu 1] -underline [lindex $menu 2] -menu .m.$mn.m -font -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*
		makemenu .m.$mn.m $mn
		pack .m.$mn -side [lindex $menu 3]
	}
	pack .m -side top -fill x
}

makemenus


frame .tb -relief raised -bd 1
proc maketoolbar {tb toolbar} {
	global	ownpath options tooldefs

	frame $tb
	set fn -1
	set tf {}
	foreach tool "$options($toolbar) seperator" {
		if {$tf == {}} {
			incr fn
			set tf $tb.f$fn
			frame $tf
		}
		if {[string trim [string tolower $tool]] == {seperator}} {
			pack $tf -side left -padx 10
			set tf {}
		} else {
			set mn $tb.$tool
			set img [image create pixmap -file "$ownpath/$options(iconpath)/$tool.xpm"]
			button $mn -command [list command [lindex $tooldefs($tool) 1]] -image $img -relief flat
			pack $mn -in $tf -side left -ipadx 2 -ipady 2
			if {[lindex $tooldefs($tool) 0] != {}} {
				.balloon bind $mn -balloonmsg [lindex $tooldefs($tool) 0]
			}
		}
	}
}

maketoolbar .tb.tb0 toolbar.0

pack .tb.tb0 -side left


proc addcolormenu {menu} {
	global	modes

	foreach mode $modes {
		$menu add radiobutton -variable fmode -value $mode -command "file_set_mode $mode" -label $mode
	}
}

proc make_option_menu {w vlist var com} {
	global $vlist

	tixOptionMenu $w -variable $var -options {menubutton.width 5 menubutton.anchor c font -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*} 
	eval set vars \$$vlist
 	foreach v $vars {
		if {$v == {}} {
			set name {plain}
		} else {
			set name $v
		}
		$w add command $v -label $name
	}
	$w configure -command $com
}

proc makeoptionext {tb} {
	global	ownpath options mode fno optiondefs

	set fn 4
	set tf {}
	set tools $mode($fno)
	if {$tools == {}} {
		set tools {plain}
		}
	foreach tool $optiondefs($tools) {
		if {$tf == {}} {
			incr fn
			set tf $tb.f$fn
			frame $tf
		}
		set mn $tb.[lindex $tool 1]
		switch [lindex $tool 0] {
			opt {
				make_option_menu $mn [lindex $tool 3] [lindex $tool 4] [lindex $tool 5]
				pack $mn -in $tf -side left
			}
			com	{
				button $mn -command [lindex $tool 4] -image [image create pixmap -file $ownpath/$options(iconpath)/[lindex $tool 3].xpm]
				pack $mn -in $tf -side left -ipadx 2 -ipady 2
			}
			radio	{
				eval radiobutton $mn [lindex $tool 3] -value [lindex $tool 1] -variable [lindex $tool 4] -command \[lindex \$tool 5\]
				pack $mn -in $tf -side left
			}
			check	{
				checkbutton $mn -selectcolor {} -indicatoron 0 -image [image create pixmap -file $ownpath/$options(iconpath)/[lindex $tool 3].xpm] -variable [lindex $tool 4]  -bd 1 -command [lindex $tool 5]
				pack $mn -in $tf -side left -ipadx 2 -ipady 2
			}
		}
		if {[lindex $tool 0] == {new}} {
			pack $tf -side [lindex $tool 1] -padx 2
			set tf {}
		} else {
			if {$options(global.showballoon) && [lindex $tool 2] != {}} {
				.balloon bind $mn -balloonmsg [lindex $tool 2]
			}
		}
	}

}

proc makeoptionbar {tb toolbar} {
	global	ownpath options

	frame $tb -relief raised  -bd 1
	set fn -1
	set tf {}
	foreach tool $toolbar {
		if {$tf == {}} {
			incr fn
			set tf $tb.f$fn
			frame $tf
		}
		set mn $tb.[lindex $tool 1]
		switch [lindex $tool 0] {
			opt {
				make_option_menu $mn [lindex $tool 3] [lindex $tool 4] [lindex $tool 5]
				pack $mn -in $tf -side left
			}
			com	{
				button $mn -command [lindex $tool 4] -image [image create pixmap -file $ownpath/$options(iconpath)/[lindex $tool 3].xpm]
				pack $mn -in $tf -side left -ipadx 2 -ipady 2
			}
			radio	{
				eval radiobutton $mn [lindex $tool 3] -value [lindex $tool 1] -variable [lindex $tool 4] -command \[lindex \$tool 5\]
				pack $mn -in $tf -side left
			}
			check	{
				checkbutton $mn -selectcolor {} -indicatoron 0 -image [image create pixmap -file $ownpath/$options(iconpath)/[lindex $tool 3].xpm] -variable [lindex $tool 4]  -bd 2 -relief raised -command [lindex $tool 5]
				pack $mn -in $tf -side left -ipadx 2 -ipady 2
			}
		}
		if {[lindex $tool 0] == {new}} {
			pack $tf -side [lindex $tool 1] -padx 2
			set tf {}
		} else {
			if {$options(global.showballoon) && [lindex $tool 2] != {}} {
				.balloon bind $mn -balloonmsg [lindex $tool 2]
			}
		}
	}
	makeoptionext $tb
}

addcolormenu .m.options.m.options_actual
	showinfo "Goto bookmark <$mode($fno)>." 

makeoptionbar .ob $optionbar


proc toolbar_show {no} {
	global	options acttoolbar state

	if {$no > $options(toolbars)} {
		set no $options(toolbars)
	} elseif {$no < 1} {
		set no 1
	}
	if {$acttoolbar == $no} return
	if {$acttoolbar != {}} {
		pack forget .utb.tb$acttoolbar
	}
	pack .utb.tb$no -side left
	.utb.updown.down configure -state $state([expr $no > 1])
	.utb.updown.up configure -state $state([expr $no < $options(toolbars)])
	set acttoolbar $no
}


tixNoteBook .nb -ipadx 0 -ipady 0
.nb subwidget nbframe config -font -*-helvetica-medium-r-medium-*-12-*-*-*-*-*-*-*
pack .nb -side top -expand yes -fill both -padx 4 -pady 1


set searchbar {
	{com2 search {Initiate searching} search2 {command {search search}}}
	{new left}
	{check2 dir {Search direction} search(dir) search2_forw -forwards search2_back -backwards}
	{check2 type {Search type} search(type) search2_exact -exact search2_regexp -regexp}
	{check2 case {Search case sensitivity} search(case) search2_case {} search2_nocase -nocase}
	{new left}
	{entry searchstr {Search string} search(search) 25}
	{new left}
	{com2 replace {Replace & Search} search2_replace {command {search replace}}}
	{com2 replaceall {Replace & Search all} search2_replaceall {command {search replaceall}}}
	{entry replacestr {Replace string} search(replace) 25}
	{new left}
	{com2 hide {Hide search bar} search2_stop {command {search exit}}}
	{new right}
}

proc makesearchbar {tb toolbar} {
	global	search ownpath searchdefs options

	frame $tb   -bd 1 -relief raised
	set fn -1
	set tf {}
	foreach tool $toolbar {
		if {$tf == {}} {
			incr fn
			set tf $tb.f$fn
			frame $tf
		}
		set mn $tb.[lindex $tool 1]
		switch [lindex $tool 0] {
			com2	{
				button $mn -command [lindex $tool 4] -image [image create pixmap -file "$ownpath/$options(iconpath)/[lindex $tool 3].xpm"] -relief groove
				pack $mn -in $tf -side left -ipadx 2 -ipady 2
			}
			entry	{
				entry $mn -textvariable [lindex $tool 3] -width [lindex $tool 4] -relief groove
				pack $mn -in $tf -side left -ipadx 2 -ipady 2
				bind $mn <Control-i> { command {search swapstr} }
				bind $mn <Control-f> { set search(panel) {}; command {search forward} }
				bind $mn <Control-b> { set search(panel) {}; command {search backward} }
				bind $mn <Return> { set search(panel) {}; command {search search} }
				bind $mn <Control-s> { edit_search }
				bind $mn <Control-r> { set search(panel) {}; command {search replace} }
				bind $mn <Control-A> { set search(panel) {}; command {search replaceall} }
				bind $mn <Escape>    { set search(panel) {}; command {search exit} }

			}
			check2	{
				checkbutton $mn -selectcolor {} -indicatoron 0 -image [image create pixmap -file "$ownpath/$options(iconpath)/[lindex $tool 4].xpm"] -variable [lindex $tool 3] -offvalue [lindex $tool 5] -selectimage [image create pixmap -file $ownpath/$options(iconpath)/[lindex $tool 6].xpm] -onvalue [lindex $tool 7] -bd 0
				pack $mn -in $tf -side left -ipadx 2 -ipady 2
			}
		}
		if {[lindex $tool 0] == {new}} {
			pack $tf -side [lindex $tool 1] -padx 2
			set tf {}
		} else {
			if {$options(global.showballoon) && [lindex $tool 2] != {}} {
				.balloon bind $mn -balloonmsg [lindex $tool 2]
			}
		}
	}
}

makesearchbar .sb $searchbar


frame .ib  -bd 1 -relief raised

set infodefs {
	{label y ypos {-width 5 -anchor e -relief groove  -bd 2} {Cursor line number} {-side right -padx 5}}
	{label x xpos {-width 4 -anchor e -relief groove  -bd 2} {Cursor column} {-side right -padx 5}}
	{label project project(info) {-width 16 -anchor c -relief groove  -bd 2} {Project name} {-side right -padx 5}}
	{entry info info(text) {-width 50 -relief groove  -bd 2} {} {-side left -padx 10 -fill x -expand yes}}
}

proc makeinfobar {w} {
	global infodefs options

	foreach entry $infodefs {
		set wn $w.[lindex $entry 1]
		eval [lindex $entry 0] $wn [lindex $entry 3] -fg black -textvariable [lindex $entry 2]
		if {$options(global.showballoon) && [lindex $entry 4] != {}} {
			.balloon bind $wn -balloonmsg [lindex $entry 4]
		}
		eval pack $wn [lindex $entry 5]
	}
	unset infodefs
}

makeinfobar .ib

bind .ib.info <Return> {
	set com $info(text)
	incr info(no)
	set info(text) {}
	command $com
}

bind .ib.info <Enter> {
	incr info(no)
	set info(text) {}
	focus %W
}

bind .ib.info <FocusIn> {
	incr info(no)
	set info(text) {}
	focus %W
}


proc toggle_bar {tb afterlist opt} {
	global	options

	set slaves [pack slaves .]
	if {$options($opt)} {
		foreach after $afterlist {
			if {[lsearch $slaves $after] != -1} break
		}
		eval pack $tb -after $after -side top -fill x
	} else {
		if {[lsearch $slaves $tb] != -1} {
			pack forget $tb
		}
	}
	
}

toggle_bar .tb .m global.showtoolbar
toggle_bar .ob {.tb .m} global.showoptionbar
toggle_bar .ib {.sb .nb} global.showinfobar
